<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: array2d_kernel_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_88666718ada201f42835d1b550e3d318.html">array2d</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">array2d_kernel_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2006  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_ARRAY2D_KERNEl_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_ARRAY2D_KERNEl_ABSTRACT_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../interfaces/enumerable.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../serialize.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../geometry/rectangle_abstract.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        <span class="keyword">typename</span> mem_manager = <a class="code" href="namespacedlib.html#ae8aaef18fce6452263f46535116308ca">default_memory_manager</a> </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        &gt;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="keyword">class </span>array2d : <span class="keyword">public</span> enumerable&lt;T&gt;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    {</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="comment">// ----------------------------------------</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160; </div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        <span class="keyword">typedef</span> T type;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keyword">typedef</span> mem_manager mem_manager_type;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;         </div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="comment">// ----------------------------------------</span></div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keyword">class </span>row </div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        {</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keyword">public</span>:</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;            <span class="keywordtype">long</span> nc (</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            ) <span class="keyword">const</span>;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            <span class="keyword">const</span> T&amp; operator[] (</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;                <span class="keywordtype">long</span> column</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            ) <span class="keyword">const</span>;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            T&amp; operator[] (</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;                <span class="keywordtype">long</span> column</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            );</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        <span class="keyword">private</span>:</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            <span class="comment">// restricted functions</span></div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            row();</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            row&amp; operator=(row&amp;);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        };</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160; </div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        <span class="comment">// ----------------------------------------</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        array2d (</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        );</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        array2d (</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            <span class="keywordtype">long</span> rows,</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            <span class="keywordtype">long</span> cols </div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        );</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="keyword">virtual</span> ~array2d (</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        ); </div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keywordtype">void</span> clear (</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        );</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordtype">long</span> nc (</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        <span class="keywordtype">long</span> nr (</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="keywordtype">void</span> set_size (</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            <span class="keywordtype">long</span> rows,</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;            <span class="keywordtype">long</span> cols</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        );</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        row operator[] (</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            <span class="keywordtype">long</span> row_index</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        );</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="keyword">const</span> row operator[] (</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;            <span class="keywordtype">long</span> row_index</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;            array2d&amp; item</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        );</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="keywordtype">long</span> width_step (</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160; </div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        <span class="comment">// restricted functions</span></div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        array2d(array2d&amp;);        <span class="comment">// copy constructor</span></div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        array2d&amp; operator=(array2d&amp;);    <span class="comment">// assignment operator</span></div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160; </div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    };</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160; </div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        <span class="keyword">typename</span> mem_manager</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        &gt;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        array2d&lt;T,mem_manager&gt;&amp; a, </div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        array2d&lt;T,mem_manager&gt;&amp; b </div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    ) { a.swap(b); }   </div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        <span class="keyword">typename</span> mem_manager</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        &gt;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    <span class="keywordtype">void</span> serialize (</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        <span class="keyword">const</span> array2d&lt;T,mem_manager&gt;&amp; item, </div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        std::ostream&amp; out </div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    );   </div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        <span class="keyword">typename</span> mem_manager</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        &gt;</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    <span class="keywordtype">void</span> deserialize (</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        array2d&lt;T,mem_manager&gt;&amp; item, </div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        std::istream&amp; in</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    );   </div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;}</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160; </div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;<span class="preprocessor">#endif // DLIB_ARRAY2D_KERNEl_ABSTRACT_ </span></div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html_ae8aaef18fce6452263f46535116308ca"><div class="ttname"><a href="namespacedlib.html#ae8aaef18fce6452263f46535116308ca">dlib::default_memory_manager</a></div><div class="ttdeci">memory_manager_stateless_kernel_1&lt; char &gt; default_memory_manager</div><div class="ttdef"><b>Definition:</b> algs.h:129</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
